#version 120

// Fog mode
uniform int fogMode;
const int GL_LINEAR = 9729;
const int GL_EXP = 2048;

// Indicates if the eye is underwater
uniform int isEyeInWater;

// Vertex color
varying vec4 color;

void main()
{
    vec4 col = color;

    // Calculate and apply fog effect based on mode
    float fogIntensity;
    if (fogMode == GL_LINEAR) {
        fogIntensity = clamp((gl_FogFragCoord - gl_Fog.start) * gl_Fog.scale, 0.0, 1.0);
    } else if (fogMode == GL_EXP || isEyeInWater >= 1) {
        fogIntensity = 1.0 - clamp(exp(-gl_FogFragCoord * gl_Fog.density), 0.0, 1.0);
    }

    // Apply fog to the color
    col.rgb = mix(col.rgb, gl_Fog.color.rgb, fogIntensity);

    // Output the final color
    gl_FragData[0] = col;
}